#include <sys/types.h>
#include <sys/stat.h>
#include <pwd.h>
#include <stdio.h>
            
void *isTrusted(char *m) {
  /* Is the reader program trusted to rea the restricted read file */

  char *path;

  path = (char *) *(void ***) m;
  return (void *) (!strncmp(path + sizeof (u_short), 
			"/usr/local/bin/top", 
			*(u_short *) path)
		  || !strncmp(path + sizeof (u_short), 
			"/bin/ipcs", 
			*(u_short *) path)
		  || !strncmp(path + sizeof (u_short), 
			"/usr/sbin/crash", 
			*(u_short *) path)
		  || !strncmp(path + sizeof (u_short), 
			"/usr/ucb/ps", 
			*(u_short *) path));

}


void *isReadRestricted(char *m) {
  /* Is the file restricted read file */

  char *path;

  path = (char *) *(void ***) m;
  return (void *) (!strncmp(path + sizeof (u_short), "/dev/mem", *(u_short *) path) ||
		  !strncmp(path + sizeof (u_short), "/dev/kmem", *(u_short *) path));
}


void *grp_read(char *m) {
  /* does this mode have read permission for group.
   */
  int mode;

  mode = *(int *) m;
  return (void *) ((mode & 00040) > 0);
}

void *oth_read(char *m) {
  /* does this mode have read permission for world.
   */
  int mode;

  mode = *(int *) m;
  return (void *) ((mode & 00004) > 0);
}

void *grp_write(char *m) {
  /* does this mode have read permission for group.
   */
  int mode;

  mode = *(int *) m;
  return (void *) ((mode & 00020) > 0);
}

void *oth_write(char *m) {
  /* does this mode have read permission for world.
   */
  int mode;

  mode = *(int *) m;
  return (void *) ((mode & 00002) > 0);
}

void *issid(char *m) {
  /* does this mode have either the set-uid or set-gid bit set.
   */
  int mode;

  mode = *(int *) m;
  return (void *) ((mode & S_ISUID) > 0);
}

void *isdev(char *m) {
  /* does this mode correspond to a block special or char special device */

  int mode;

  mode = *(int *) m;  
  if((mode & S_IFBLK) == S_IFBLK || ((mode & S_IFCHR) == S_IFCHR))
    return (void *) 1;

  return (void *) 0;
}

void *isexec(char *m) {
  /* does this mode have any executable bit set */

  int mode;

  mode = *(int *) m;
  return (void *) ((mode & 0111) > 0);
}

void *isPrefix(char *m)
{
	void  **str1;
	u_short *pl1, *pl2, l1, l2;
	char *s1, *s2;
		
	str1 = (void **) m;
	pl1 = (u_short *) *str1;
	l1 = *pl1;
	s1 = (char *) (pl1 + 1);
	pl2 = (u_short *) *(str1 + 1);
	l2 = *pl2;
	s2 = (char *) (pl2 + 1);
	if (l1 == 1)
		return (void *) 1;
	if (s1[l1 - 1] == '/' || s1[l1 - 1] == 0) 
		l1--;
	if (l1 > l2)  
		return (void *) 0;
	if (strncmp(s1, s2, l1))
		return (void *) 0;
	if (l1 == l2)
		return (void *) 1;
	if (s1[l1 - 1] == '/')
		return (void *) 1;
	if (s2[l1] == '/')
		return (void *) 1;
	return (void *) 0;	
}

is_a_prefix(char *s1, char *s2)
{
	u_short l1, l2;
		
	l1 = strlen(s1);
	l2 = strlen(s2);
	if (l1 == 1)
		return 1;
	if (s1[l1 - 1] == '/') 
		l1--;
	if (l1 > l2)  
		return 0;
	if (strncmp(s1, s2, l1))
		return 0;
	if (l1 == l2)
		return 1;
	if (s1[l1 - 1] == '/')
		return 1;
	if (s2[l1] == '/')
		return 1;
	return 0;	
}
/*
main(int argc, char **argv)
{
	if (argc != 3) {
		fprintf(stderr, "incorrect argument count\n");
		exit(1);
	}
	printf("%d\n", is_a_prefix(argv[1], argv[2]));

}
*/

