#include <stdio.h>
#include <signal.h>

#ifndef TRUE
#define TRUE 1
#endif

#ifndef FALSE
#define FALSE 0
#endif

#define standard   1   /* NADF files */
#define conversion 2   /* first convert to NADF format then analyse */
#define mixed      3   /* support either of two mode above */

char *progname;
main(argc, argv)
int argc;
char *argv[];
{
    static char sed1[20] = "sed1 ";
    char *cmd, *cmdPref, *descr, *make, *proto, *strcat();
    char *I_Oobj, *C_lib_Obj, *asaxExe;
    int MODE = FALSE;
    int NewExeName = FALSE;     /* generate a new executable */
    int Lib = FALSE;            /* generate a new C-library  */
    int Fa  = FALSE;            /* generate a new I/0 module */
    int mode = standard;        /* auxiliary that contains the mode */

    progname = *argv;
    argv++;
    argc--;
    I_Oobj = "";
    while (argc-- > 0) { /* parsing command line arguments */
	if (strcmp(*argv, "-s") == 0 && !MODE) {
	    MODE = TRUE;
	    mode = standard;
	    argv++;
	} else if (strcmp(*argv, "-c") == 0 && !MODE) {
	    MODE = TRUE;
	    mode = conversion;
	    argv++;
	} else if (strcmp(*argv, "-cs") == 0 && !MODE) {
	    MODE = TRUE;
	    mode = mixed;
	    argv++;
	} else if (strcmp(*argv, "-sc") == 0 && !MODE) {
	    MODE = TRUE;
	    mode = mixed;
	    argv++;
	} else if (strcmp(*argv, "-fa") == 0 && !Fa) {
	    Fa = TRUE;
	    I_Oobj = *++argv;
	    argv++;
	    argc--;
	} else if (strcmp(*argv, "-lib") == 0 && !Lib) {
	    Lib = TRUE;
	    C_lib_Obj = *++argv;
	    argv++;
	    argc--;
	} else if (**argv == '-') {
	    printf("%s: %s illegal option\n", progname, *argv);
	    printf("usage: %s [-sc] [-lib Prefix] [-fa file1] [file2] \n",
	    progname);
	    exit(1);
	} else if (!NewExeName) {
	    NewExeName = TRUE;
	    asaxExe = *argv++;
	} else {
	    printf("%s: bad arguments\n", progname);
	    printf("usage: %s [-sc] [-lib Prefix] [-fa file1] [file2] \n",
	    progname);
	    exit(1);
	}
    }
    printf("ASAX linkage is under way. Please wait ...\n");
    if (Lib) {
	cmdPref = strcat(sed1, C_lib_Obj);
	cmdPref = strcat(sed1, ".makeAsax");
    } else {
	cmdPref = strcat(sed1, "makeAsax");
    }
    if ((cmd = (char *) malloc(60)) == NULL) {
	printf("out of memory\n");           /* allocation problem */
	exit(1);
    }
    strcpy(cmd, cmdPref);
    switch (mode) {
	case standard :
			cmd = strcat(cmd, " mode_file standard.o");
			break;
	case conversion:
			cmd = strcat(cmd, " mode_file conversion.o");
			break;

	case mixed:
			cmd = strcat(cmd, " mode_file mixed.o");
			break;
    }
    if (system(cmd))                     /* substitute mode file */
	exit(1);
    if (Fa) {
	strcpy(cmd, cmdPref);
	cmd = strcat(cmd, " obj_file ");
	cmd = strcat(cmd , I_Oobj);
	system(cmd);                     /* substitute Format Adaptor */
    }
    strcpy(cmd, cmdPref);
    if (NewExeName) {
	cmd = strcat(cmd, " asaxExec ");
	cmd = strcat(cmd , asaxExe);
    } else {
	cmd = strcat(cmd, " asaxExec asax.exec");
    }
    if (system(cmd))                      /* substitute executable name */
	exit(1);
    if ((descr = (char *) malloc(256)) == NULL) {
	printf("out of memory\n");           /* allocation problem */
	exit(1);
    }
    if ((proto = (char *) malloc(256)) == NULL) {
	printf("out of memory\n");           /* allocation problem */
	exit(1);
    }
    if ((make = (char *) malloc(256)) == NULL) {
	printf("out of memory\n");           /* allocation problem */
	exit(1);
    }
    if (Lib) {
	strcpy(descr, C_lib_Obj);
	strcpy(proto, C_lib_Obj);
	strcpy(make, C_lib_Obj);
	descr = strcat(descr, ".asax_lib.h ");
	proto = strcat(proto, ".proto.h ");
	make = strcat(make, ".makeAsax ");
    } else {
	strcpy(descr, "asax_lib.h ");
	strcpy(proto, "proto.h ");
	strcpy(make, "makeAsax ");
    }
    strcpy(cmd, "cp ");
    strcat(cmd, descr);
    strcat(cmd, " _ASAX__LIB.h");
    if (system(cmd))                      /* cp in ASAX__LIB.h */
	exit(1);
    strcpy(cmd, "cp ");
    strcat(cmd, proto);
    strcat(cmd, " _PROTO__.h");
    if (system(cmd))                      /* cp in PROTO__.h   */
	exit(1);
    strcpy(cmd, "chmod +x ");
    cmd = strcat(cmd, make);
    if (system(cmd))                     /* makefile becomes executable */
	exit(1);
    free(cmd);
    switch (mode) {
	case standard : make = strcat(make, "0 ");
			break;
	default       : make = strcat(make, "1 ");
			break;
    }
    if (system(make))                     /* regenerate a new executable */
	exit(1);
    free(make);
    free(descr);
    free(proto);
    return(0);
}
